/*
 * Sonar, entreprise quality control tool.
 * Copyright (C) 2007-2008 Hortis-GRC SA
 * mailto:be_agile HAT hortis DOT ch
 *
 * Sonar is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * Sonar is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with Sonar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02
 */
package ch.hortis.sonar.web.charts;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.OutputStream;

public class ChartServlet extends HttpServlet {

  public ChartServlet() {

  }

  public void doGet(HttpServletRequest request, HttpServletResponse response)
      throws ServletException, IOException {

    String chartType = request.getParameter("cht");
    String values = request.getParameter("chv");
    String colors = request.getParameter("chc");
    String width = request.getParameter("chw");
    String height = request.getParameter("chh");
    String rangeMax = request.getParameter("chrm");

    Chart chart = null;

    if (BarChart.NAME.equals(chartType)) {
      chart = new BarChart(width, height, colors, rangeMax);
      chart.addMeasures(values);
    } else if (PieChart.NAME.equals(chartType)) {
      chart = new PieChart(width, height, colors);
      chart.addMeasures(values);
    }

    OutputStream out = response.getOutputStream();
    try {
      response.setContentType("image/png");
      chart.exportChartAsPNG(out);
    }
    catch (Exception e) {
      System.err.println(e.toString());
    }
    finally {
      out.close();
    }
  }

}
